#include "lowlevelfunc.h"

#ifdef USE_MEM_SYSTEM
typedef struct _safemem {void *ptr;
                         size_t size;
                         struct _safemem *next;} SafeMem;
SafeMem *firstmemstr;
unsigned long maxmemusage,memusage;
#endif

void *_allocsafe(size_t size)
{ /* gibt Speicher zurck oder beendet sofort das Programm */
  void *ptr;
#ifdef USE_MEM_SYSTEM
  SafeMem *tsmptr,*tsmptr2;
#endif

  ptr=(void*)malloc(size);
  if(ptr==NULL) {
    fprintf(stderr, "No Memory!!!!Aborting\n");
    exit(1);
  }
#ifdef USE_MEM_SYSTEM
  tsmptr=malloc(sizeof(SafeMem));
  tsmptr->ptr=ptr;
  tsmptr->size=size;
  tsmptr->next=NULL;
  if(firstmemstr==NULL) {
    firstmemstr=tsmptr;
  } else {
    tsmptr2=firstmemstr;
    while(tsmptr2->next!=NULL) tsmptr2=tsmptr2->next;
    tsmptr2->next=tsmptr;
  }
  memusage+=size;
  if(memusage>maxmemusage) maxmemusage=memusage;
#endif
  return ptr;
}

#ifdef USE_MEM_SYSTEM
void _freesafe(void *p)
{
  SafeMem *tsmptr,*found,*prefound;

  tsmptr=firstmemstr;
  found=NULL;
  prefound=NULL;
  while(tsmptr!=NULL) {
    if(tsmptr->ptr==p) {
      found=tsmptr;
      break;
    }
    prefound=tsmptr;
    tsmptr=tsmptr->next;
  }
  if(found!=NULL) {
    memusage-=found->size;
    if(firstmemstr==found) {
      firstmemstr=found->next;
      free(found);
    } else {
      prefound->next=found->next;
      free(found);
    }
  } else {
    printf("Freigabe eines unauthorisierten Speichers!\n");
  }
  free(p);
}

void _memsystemcheck()
{
  SafeMem *tsmptr;
  int nr;

  tsmptr=firstmemstr;
  nr=0;
  while(tsmptr!=NULL) {
    nr++;
/*    printf("lasse nr %d free:\n",nr);
    free(tsmptr->ptr);*/
    tsmptr=tsmptr->next;
  }
#ifdef DEBUG
  printf("Es gibt noch %d nicht freigelassene Speicherstcke!\n",nr);
  printf("Maximal benutzter Speicher:%ld Bytes\n",maxmemusage);
#else
  if(nr>0) {
    printf("Es gibt noch %d nicht freigelassene Speicherstcke!\n",nr);
  }
#endif
}

void _memsysteminit()
{
#ifdef DEBUG
  printf("Init Mem-System\n");
#endif
  firstmemstr=NULL;
  maxmemusage=0;
  memusage=0;
}
#endif

char *dupstring(const char *str)
{
  char *tstr;
  tstr=(char*)_allocsafe(strlen(str)+1);
  strcpy(tstr,str);
  return tstr;
}

